<?php
class ext_breadcrumb_trail extends bcn_breadcrumb_trail
{
	//Default constructor
	function __construct()
	{
		//Need to make sure we call the constructor of bcn_breadcrumb_trail
		parent::__construct();
	}
	function page_parents($id, $frontpage)
	{
		//Use WordPress API, though a bit heavier than the old method, this will ensure compatibility with other plug-ins
		$parent = get_post($id);
		$suffix = '<ul>' . wp_list_pages('depth=1&child_of=' . $parent->post_parent.'&exclude=' . $parent->ID . '&echo=0&title_li=') . '</ul>';
		if($suffix !== '<ul></ul>')
		{
			$suffix = $this->opt['page_suffix'] . $suffix;
		}
		else
		{
			$suffix = $this->opt['page_suffix'];
		}
		//Place the breadcrumb in the trail, uses the constructor to set the title, prefix, and suffix, get a pointer to it in return
		$breadcrumb = $this->add(new bcn_breadcrumb(apply_filters('the_title', $parent->post_title), $this->opt['page_prefix'], 
			$suffix));
		//Assign the anchor properties
		$breadcrumb->set_anchor($this->opt['page_anchor'], get_permalink($id));
		//Make sure the id is valid, and that we won't end up spinning in a loop
		if($parent->post_parent >= 0 && $parent->post_parent != false && $id != $parent->post_parent && $frontpage != $parent->post_parent)
		{
			//If valid, recursively call this function
			$this->page_parents($parent->post_parent, $frontpage);
		}
	}
	function do_page()
	{
		global $post;
		$suffix = '<ul>' . wp_list_pages('depth=1&child_of=' . $post->post_parent.'&exclude=' . $post->ID . '&echo=0&title_li=') . '</ul>';
		if($suffix !== '<ul></ul>')
		{
			$suffix = $this->opt['page_suffix'] . $suffix;
		}
		else
		{
			$suffix = $this->opt['page_suffix'];
		}
		//Place the breadcrumb in the trail, uses the bcn_breadcrumb constructor to set the title, prefix, and suffix
		$this->trail[] = new bcn_breadcrumb(get_the_title(), $this->opt['page_prefix'], $suffix);
		//Done with the current item, now on to the parents
		$bcn_frontpage = get_option('page_on_front');
		//If there is a parent page let's find it
		if($post->post_parent && $post->ID != $post->post_parent && $bcn_frontpage != $post->post_parent)
		{
			$this->page_parents($post->post_parent, $bcn_frontpage);
		}
	}
}
?>